diff -uNrd ircd-ratbox-1.5-2/modules/m_help.c ircd-rb-FDF6.3a/modules/m_help.c
--- ircd-ratbox-1.5-2/modules/m_help.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_help.c	Mon May 31 00:02:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_help.c,v 1.57.2.4 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_help.c,v 1.3 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -69,7 +69,7 @@
 	mod_del_cmd(&uhelp_msgtab);
 }
 
-const char *_version = "$Revision: 1.57.2.4 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_help - HELP message handler
diff -uNrd ircd-ratbox-1.5-2/modules/m_idle.c ircd-rb-FDF6.3a/modules/m_idle.c
--- ircd-ratbox-1.5-2/modules/m_idle.c	Wed Dec 31 19:00:00 1969
+++ ircd-rb-FDF6.3a/modules/m_idle.c	Sun Jan 25 22:49:27 2004
@@ -0,0 +1,83 @@
+/*
+ *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_idle.c: Allows opers to forge IDLE times.
+ *
+ *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
+ *  Copyright (C) 1996-2002 Hybrid Development Team
+ *  Copyright (C) 2002 ircd-ratbox development team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_idle.c,v 1.1 2004/01/26 03:49:27 jailbird Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include <stdlib.h>
+
+static void mo_idle(struct Client *, struct Client *, int, char **);
+
+struct Message idle_msgtab = {
+	"IDLE", 0, 0, 0, 0, MFLG_SLOW | MFLG_UNREG, 0,
+	{m_unregistered, m_ignore, m_ignore, mo_idle}
+};
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&idle_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&idle_msgtab);
+}
+
+const char *_version = "$Revision: 1.1 $";
+#endif
+/*
+ * mo_idle - IDLE command handler
+ *      parv[0] = sender prefix   
+ *      parv[1] = servername   
+ */
+static void
+mo_idle(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	time_t last=0;
+
+	if (!MyClient(source_p))
+		return;
+
+	if (parc < 2) {
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+			   me.name, parv[0], "IDLE");
+		return;
+	}
+
+	last = atol(parv[1]);
+	if (last && ((CurrentTime - last) < source_p->user->last) && (last > 0))
+		source_p->user->last = CurrentTime - last;
+}
diff -uNrd ircd-ratbox-1.5-2/modules/m_info.c ircd-rb-FDF6.3a/modules/m_info.c
--- ircd-ratbox-1.5-2/modules/m_info.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_info.c	Tue Jun  1 20:20:14 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_info.c,v 1.88.2.10 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_info.c,v 1.6 2004/06/02 00:20:14 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -47,13 +47,15 @@
 static void send_birthdate_online_time(struct Client *source_p);
 static void send_info_text(struct Client *source_p);
 
+#if 0
 static void m_info(struct Client *, struct Client *, int, char **);
+#endif
 static void ms_info(struct Client *, struct Client *, int, char **);
 static void mo_info(struct Client *, struct Client *, int, char **);
 
 struct Message info_msgtab = {
 	"INFO", 0, 0, 0, 0, MFLG_SLOW, 0,
-	{m_unregistered, m_info, ms_info, m_ignore, mo_info}
+	{m_unregistered, m_not_oper, ms_info, m_ignore, mo_info}
 };
 #ifndef STATIC_MODULES
 
@@ -68,7 +70,7 @@
 {
 	mod_del_cmd(&info_msgtab);
 }
-const char *_version = "$Revision: 1.88.2.10 $";
+const char *_version = "$Revision: 1.6 $";
 #endif
 
 /*
@@ -168,11 +170,6 @@
 	 &ConfigFileEntry.fname_userlog,
 	 "User log file"},
 	{
-	 "glines",
-	 OUTPUT_BOOLEAN,
-	 &ConfigFileEntry.glines,
-	 "G-line (network-wide K-line) support"},
-	{
 	 "gline_time",
 	 OUTPUT_DECIMAL,
 	 &ConfigFileEntry.gline_time,
@@ -474,6 +471,18 @@
 	 "Enable /KNOCK",
 	 },
 	{
+	 "opers_see_hidden",
+	 OUTPUT_BOOLEAN_YN,
+	 &ConfigChannel.opers_see_hidden,
+	 "Opers can see +i users, as well as +s and +p channels, on /names, /list, /whois, and /who.",
+	 },
+	{
+	 "opers_see_topic",
+	 OUTPUT_BOOLEAN_YN,
+	 &ConfigChannel.opers_see_topic,
+	 "Opers can see topics on all channels.",
+	 },
+	{
 	 "disable_hidden",
 	 OUTPUT_BOOLEAN_YN,
 	 &ConfigServerHide.disable_hidden,
@@ -510,6 +519,54 @@
 	 "Hide servernames from users",
 	 },
 	{
+	 "check_clone",
+	 OUTPUT_BOOLEAN,
+	 &ConfigFileEntry.check_clone,
+	 "Clonebot protection",
+	 },
+	{
+	 "check_clone_limit",
+	 OUTPUT_DECIMAL,
+	 &ConfigFileEntry.check_clone_limit,
+	 "Maximum number of connections per host",
+	 },
+	{
+	 "check_clone_period",
+	 OUTPUT_DECIMAL,
+	 &ConfigFileEntry.check_clone_period,
+	 "Connection check interval",
+	 },
+	{
+	 "check_clone_delay",
+	 OUTPUT_DECIMAL,
+	 &ConfigFileEntry.check_clone_delay,
+	 "How long to delay clone checks after server startup",
+	 },
+	{
+	 "inu_server_can_op",
+	 OUTPUT_BOOLEAN,
+	 &ConfigFileEntry.inu_server_can_op,
+	 "Users can make server op them",
+	 },
+	{
+	 "inu_ignore_bans",
+	 OUTPUT_BOOLEAN,
+	 &ConfigFileEntry.inu_ignore_bans,
+	 "Can join channel despite ban,invite,etc",
+	 },
+	{
+	 "inu_serv_can_collide",
+	 OUTPUT_BOOLEAN,
+	 &ConfigFileEntry.inu_serv_can_collide,
+	 "Hide kills by faking nick collisions",
+	 },
+	{
+	 "jb_serv_can_kick",
+	 OUTPUT_BOOLEAN,
+	 &ConfigFileEntry.jb_serv_can_kick,
+	 "Allow for anon kicks from the server",
+	 },
+	{
 	 "links_delay",
 	 OUTPUT_DECIMAL,
 	 &ConfigServerHide.links_delay,
@@ -530,6 +587,8 @@
 /*
 */
 
+#if 0
+/* Non-OPER INFO has been disabled for security reasons. -JailBird */
 /*
 ** m_info
 **  parv[0] = sender prefix
@@ -570,6 +629,7 @@
 	sendto_one(source_p, form_str(RPL_ENDOFINFO), me.name, parv[0]);
 
 }				/* m_info() */
+#endif
 
 /*
 ** mo_info
diff -uNrd ircd-ratbox-1.5-2/modules/m_invite.c ircd-rb-FDF6.3a/modules/m_invite.c
--- ircd-ratbox-1.5-2/modules/m_invite.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_invite.c	Mon May 31 00:02:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_invite.c,v 1.66.2.4 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_invite.c,v 1.4 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -63,7 +63,7 @@
 	mod_del_cmd(&invite_msgtab);
 }
 
-const char *_version = "$Revision: 1.66.2.4 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 
 /*
@@ -79,6 +79,7 @@
 	struct Channel *chptr;
 	struct membership *msptr;
 	int chop = 1;
+	int sline;
 
 	if(EmptyString(parv[2]))
 	{
@@ -137,8 +138,9 @@
 		return;
 	}
 
+	sline = IsSLine(source_p);
 	msptr = find_channel_membership(chptr, source_p);
-	if(MyClient(source_p) && (msptr == NULL))
+	if(MyClient(source_p) && (msptr == NULL) && !sline)
 	{
 		sendto_one(source_p, form_str(ERR_NOTONCHANNEL), me.name, parv[0], parv[2]);
 		return;
@@ -153,7 +155,7 @@
 
 	/* we initialise chop to 1, so it will always be 1 for remote users */
 	if(MyClient(source_p))
-		chop = is_chanop(msptr);
+		chop = is_chanop(msptr) || sline;
 
 	if(chptr && (chptr->mode.mode & MODE_INVITEONLY))
 	{
diff -uNrd ircd-ratbox-1.5-2/modules/m_ison.c ircd-rb-FDF6.3a/modules/m_ison.c
--- ircd-ratbox-1.5-2/modules/m_ison.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_ison.c	Mon May 31 00:02:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_ison.c,v 1.44.2.3 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_ison.c,v 1.3 2004/05/31 04:02:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -61,7 +61,7 @@
 {
 	mod_del_cmd(&ison_msgtab);
 }
-const char *_version = "$Revision: 1.44.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 static char buf[BUFSIZE];
diff -uNrd ircd-ratbox-1.5-2/modules/m_join.c ircd-rb-FDF6.3a/modules/m_join.c
--- ircd-ratbox-1.5-2/modules/m_join.c	Thu May 20 08:06:35 2004
+++ ircd-rb-FDF6.3a/modules/m_join.c	Thu Jun 17 13:09:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_join.c,v 1.130.2.9 2004/05/20 12:06:35 leeh Exp $
+ *  $Id: m_join.c,v 1.5 2004/06/17 17:09:59 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -66,7 +66,7 @@
 {
 	mod_del_cmd(&join_msgtab);
 }
-const char *_version = "$Revision: 1.130.2.9 $";
+const char *_version = "$Revision: 1.5 $";
 
 #endif
 static void do_join_0(struct Client *client_p, struct Client *source_p);
@@ -223,7 +223,8 @@
 			check_spambot_warning(source_p, name);
 
 		/* can_join checks for +i key, bans etc */
-		if((i = can_join(source_p, chptr, key)))
+		i = can_join(source_p, chptr, key);
+		if (i && (i != -1))
 		{
 			sendto_one(source_p, form_str(i), me.name, parv[0], name);
 			if(successful_join_count > 0)
@@ -292,6 +293,20 @@
 				      chptr->chname, parv[0]);
 		}
 
+		if (i == -1)
+		{
+			struct membership *msptr;
+			msptr = find_channel_membership(chptr, source_p);
+			if (msptr != NULL)
+			{
+				change_channel_membership(msptr, CHFL_SAFE, CHFL_DEOPPED);
+				sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +z %s", me.name,
+						     chptr->chname, source_p->name);
+				sendto_server(NULL, NULL, NOCAPS, NOCAPS,
+					      ":%s MODE %s +z %s", me.name, chptr->chname, source_p->name);
+			}
+		}
+
 		del_invite(chptr, source_p);
 
 		if(chptr->topic != NULL)
@@ -352,11 +367,6 @@
 		if(parc > 2)
 		{
 			new_ts = atoi(parv[2]);
-		}
-		else
-		{
-			ts_warn("User on %s remotely JOINing new channel with no TS",
-				source_p->user->server);
 		}
 	}
 }
diff -uNrd ircd-ratbox-1.5-2/modules/m_kline.c ircd-rb-FDF6.3a/modules/m_kline.c
--- ircd-ratbox-1.5-2/modules/m_kline.c	Thu May 20 16:35:16 2004
+++ ircd-rb-FDF6.3a/modules/m_kline.c	Mon May 31 00:02:23 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_kline.c,v 1.158.2.10 2004/05/20 20:35:16 leeh Exp $
+ *  $Id: m_kline.c,v 1.3 2004/05/31 04:02:23 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -80,7 +80,7 @@
 	mod_del_cmd(&kline_msgtab);
 	mod_del_cmd(&dline_msgtab);
 }
-const char *_version = "$Revision: 1.158.2.10 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /* Local function prototypes */
diff -uNrd ircd-ratbox-1.5-2/modules/m_knock.c ircd-rb-FDF6.3a/modules/m_knock.c
--- ircd-ratbox-1.5-2/modules/m_knock.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_knock.c	Mon May 31 00:02:23 2004
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_knock.c,v 1.76.2.6 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_knock.c,v 1.3 2004/05/31 04:02:23 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -72,7 +72,7 @@
 	mod_del_cmd(&knock_msgtab);
 }
 
-const char *_version = "$Revision: 1.76.2.6 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /* m_knock
diff -uNrd ircd-ratbox-1.5-2/modules/m_links.c ircd-rb-FDF6.3a/modules/m_links.c
--- ircd-ratbox-1.5-2/modules/m_links.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_links.c	Mon May 31 00:02:23 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_links.c,v 1.52.2.5 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_links.c,v 1.3 2004/05/31 04:02:23 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -62,7 +62,7 @@
 	mod_del_cmd(&links_msgtab);
 }
 
-const char *_version = "$Revision: 1.52.2.5 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_links - LINKS message handler
diff -uNrd ircd-ratbox-1.5-2/modules/m_list.c ircd-rb-FDF6.3a/modules/m_list.c
--- ircd-ratbox-1.5-2/modules/m_list.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_list.c	Tue Jun  1 20:20:14 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_list.c,v 1.66.2.7 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_list.c,v 1.6 2004/06/02 00:20:14 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -67,7 +67,7 @@
 {
 	mod_del_cmd(&list_msgtab);
 }
-const char *_version = "$Revision: 1.66.2.7 $";
+const char *_version = "$Revision: 1.6 $";
 #endif
 
 /*
@@ -133,6 +133,10 @@
 	struct Channel *chptr;
 	dlink_node *ptr;
 	int sendq_limit;
+	int oper_can_see = 0;
+
+	if (ConfigChannel.opers_see_hidden && IsOper(source_p))
+		oper_can_see=1;
 
 	/* give them an output limit of 90% of their sendq. --fl */
 	sendq_limit = (int) get_sendq(source_p);
@@ -153,7 +157,7 @@
 			break;
 		}
 
-		if(SecretChannel(chptr) && !IsMember(source_p, chptr))
+		if(SecretChannel(chptr) && !IsMember(source_p, chptr) && !oper_can_see)
 			continue;
 
 		sendto_one(source_p, form_str(RPL_LIST),
diff -uNrd ircd-ratbox-1.5-2/modules/m_locops.c ircd-rb-FDF6.3a/modules/m_locops.c
--- ircd-ratbox-1.5-2/modules/m_locops.c	Thu May 20 16:35:16 2004
+++ ircd-rb-FDF6.3a/modules/m_locops.c	Mon May 31 00:02:23 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_locops.c,v 1.41.2.5 2004/05/20 20:35:16 leeh Exp $
+ *  $Id: m_locops.c,v 1.3 2004/05/31 04:02:23 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -61,7 +61,7 @@
 	mod_del_cmd(&locops_msgtab);
 }
 
-const char *_version = "$Revision: 1.41.2.5 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /*
diff -uNrd ircd-ratbox-1.5-2/modules/m_lusers.c ircd-rb-FDF6.3a/modules/m_lusers.c
--- ircd-ratbox-1.5-2/modules/m_lusers.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_lusers.c	Mon May 31 00:02:23 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_lusers.c,v 1.37.2.3 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_lusers.c,v 1.3 2004/05/31 04:02:23 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -58,7 +58,7 @@
 	mod_del_cmd(&lusers_msgtab);
 }
 
-const char *_version = "$Revision: 1.37.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_lusers - LUSERS message handler
diff -uNrd ircd-ratbox-1.5-2/modules/m_map.c ircd-rb-FDF6.3a/modules/m_map.c
--- ircd-ratbox-1.5-2/modules/m_map.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_map.c	Mon May 31 00:02:23 2004
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_map.c,v 1.28.2.2 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_map.c,v 1.3 2004/05/31 04:02:23 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -54,7 +54,7 @@
   mod_del_cmd(&map_msgtab);
 }
 
-const char *_version = "$Revision: 1.28.2.2 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 static char buf[BUFSIZE];
diff -uNrd ircd-ratbox-1.5-2/modules/m_motd.c ircd-rb-FDF6.3a/modules/m_motd.c
--- ircd-ratbox-1.5-2/modules/m_motd.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_motd.c	Mon May 31 00:02:23 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_motd.c,v 1.44.2.6 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_motd.c,v 1.3 2004/05/31 04:02:23 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -60,7 +60,7 @@
 	mod_del_cmd(&motd_msgtab);
 }
 
-const char *_version = "$Revision: 1.44.2.6 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /*
diff -uNrd ircd-ratbox-1.5-2/modules/m_names.c ircd-rb-FDF6.3a/modules/m_names.c
--- ircd-ratbox-1.5-2/modules/m_names.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_names.c	Mon May 31 00:02:23 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_names.c,v 1.71.2.5 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_names.c,v 1.3 2004/05/31 04:02:23 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -66,7 +66,7 @@
 	mod_del_cmd(&names_msgtab);
 }
 
-const char *_version = "$Revision: 1.71.2.5 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /************************************************************************
diff -uNrd ircd-ratbox-1.5-2/modules/m_oper.c ircd-rb-FDF6.3a/modules/m_oper.c
--- ircd-ratbox-1.5-2/modules/m_oper.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_oper.c	Mon May 31 00:02:24 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_oper.c,v 1.70.2.3 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_oper.c,v 1.3 2004/05/31 04:02:24 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -75,7 +75,7 @@
 	mod_del_cmd(&oper_msgtab);
 }
 
-const char *_version = "$Revision: 1.70.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /*
diff -uNrd ircd-ratbox-1.5-2/modules/m_operspy.c ircd-rb-FDF6.3a/modules/m_operspy.c
--- ircd-ratbox-1.5-2/modules/m_operspy.c	Thu May 20 17:15:37 2004
+++ ircd-rb-FDF6.3a/modules/m_operspy.c	Mon May 31 00:02:24 2004
@@ -26,7 +26,7 @@
  * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  * POSSIBILITY OF SUCH DAMAGE.
  *
- * $Id: m_operspy.c,v 1.4.4.1 2004/05/20 21:15:37 leeh Exp $
+ * $Id: m_operspy.c,v 1.3 2004/05/31 04:02:24 jailbird Exp $
  */
 #include "stdinc.h"
 #include "tools.h"
@@ -58,7 +58,7 @@
 	mod_del_cmd(&operspy_msgtab);
 }
 
-const char *_version = "$Revision: 1.4.4.1 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 static void
diff -uNrd ircd-ratbox-1.5-2/modules/m_operwall.c ircd-rb-FDF6.3a/modules/m_operwall.c
--- ircd-ratbox-1.5-2/modules/m_operwall.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_operwall.c	Mon May 31 00:02:24 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_operwall.c,v 1.46.2.5 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_operwall.c,v 1.3 2004/05/31 04:02:24 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -57,7 +57,7 @@
 	mod_del_cmd(&operwall_msgtab);
 }
 
-const char *_version = "$Revision: 1.46.2.5 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * mo_operwall - OPERWALL message handler
diff -uNrd ircd-ratbox-1.5-2/modules/m_pass.c ircd-rb-FDF6.3a/modules/m_pass.c
--- ircd-ratbox-1.5-2/modules/m_pass.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_pass.c	Mon May 31 00:02:24 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_pass.c,v 1.36.2.3 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_pass.c,v 1.3 2004/05/31 04:02:24 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -55,7 +55,7 @@
 	mod_del_cmd(&pass_msgtab);
 }
 
-const char *_version = "$Revision: 1.36.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_pass() - Added Sat, 4 March 1989
diff -uNrd ircd-ratbox-1.5-2/modules/m_ping.c ircd-rb-FDF6.3a/modules/m_ping.c
--- ircd-ratbox-1.5-2/modules/m_ping.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_ping.c	Mon May 31 00:02:24 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_ping.c,v 1.45.2.3 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_ping.c,v 1.3 2004/05/31 04:02:24 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -59,7 +59,7 @@
 	mod_del_cmd(&ping_msgtab);
 }
 
-const char *_version = "$Revision: 1.45.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
 ** m_ping
diff -uNrd ircd-ratbox-1.5-2/modules/m_pong.c ircd-rb-FDF6.3a/modules/m_pong.c
--- ircd-ratbox-1.5-2/modules/m_pong.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_pong.c	Mon May 31 00:02:24 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_pong.c,v 1.42.2.6 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_pong.c,v 1.3 2004/05/31 04:02:24 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -62,7 +62,7 @@
 	mod_del_cmd(&pong_msgtab);
 }
 
-const char *_version = "$Revision: 1.42.2.6 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 static void
 ms_pong(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
diff -uNrd ircd-ratbox-1.5-2/modules/m_post.c ircd-rb-FDF6.3a/modules/m_post.c
--- ircd-ratbox-1.5-2/modules/m_post.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_post.c	Mon May 31 00:02:24 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_post.c,v 1.24.2.3 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_post.c,v 1.3 2004/05/31 04:02:24 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -71,7 +71,7 @@
 	mod_del_cmd(&put_msgtab);
 }
 
-const char *_version = "$Revision: 1.24.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
 ** mr_dumb_proxy
diff -uNrd ircd-ratbox-1.5-2/modules/m_rehash.c ircd-rb-FDF6.3a/modules/m_rehash.c
--- ircd-ratbox-1.5-2/modules/m_rehash.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_rehash.c	Mon May 31 00:02:24 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_rehash.c,v 1.66.2.4 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_rehash.c,v 1.5 2004/05/31 04:02:24 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -65,7 +65,7 @@
 	mod_del_cmd(&rehash_msgtab);
 }
 
-const char *_version = "$Revision: 1.66.2.4 $";
+const char *_version = "$Revision: 1.5 $";
 #endif
 /*
  * mo_rehash - REHASH message handler
@@ -192,7 +192,6 @@
 		glp_ptr = ptr->data;
 
 		MyFree(glp_ptr->reason1);
-		MyFree(glp_ptr->reason2);
 		MyFree(glp_ptr);
 		dlinkDestroy(ptr, &pending_glines);
 	}
diff -uNrd ircd-ratbox-1.5-2/modules/m_restart.c ircd-rb-FDF6.3a/modules/m_restart.c
--- ircd-ratbox-1.5-2/modules/m_restart.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_restart.c	Mon May 31 00:02:24 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_restart.c,v 1.36.2.3 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_restart.c,v 1.3 2004/05/31 04:02:24 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -60,7 +60,7 @@
 	mod_del_cmd(&restart_msgtab);
 }
 
-const char *_version = "$Revision: 1.36.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * mo_restart
diff -uNrd ircd-ratbox-1.5-2/modules/m_resv.c ircd-rb-FDF6.3a/modules/m_resv.c
--- ircd-ratbox-1.5-2/modules/m_resv.c	Thu May 20 16:35:16 2004
+++ ircd-rb-FDF6.3a/modules/m_resv.c	Mon May 31 00:02:24 2004
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_resv.c,v 1.39.2.8 2004/05/20 20:35:16 leeh Exp $
+ *  $Id: m_resv.c,v 1.3 2004/05/31 04:02:24 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -82,7 +82,7 @@
 	mod_del_cmd(&unresv_msgtab);
 }
 
-const char *_version = "$Revision: 1.39.2.8 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /*
diff -uNrd ircd-ratbox-1.5-2/modules/m_set.c ircd-rb-FDF6.3a/modules/m_set.c
--- ircd-ratbox-1.5-2/modules/m_set.c	Thu May 20 08:06:36 2004
+++ ircd-rb-FDF6.3a/modules/m_set.c	Mon May 31 00:02:25 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_set.c,v 1.64.2.7 2004/05/20 12:06:36 leeh Exp $
+ *  $Id: m_set.c,v 1.5 2004/05/31 04:02:25 jailbird Exp $
  */
 
 /* rewritten by jdc */
@@ -67,7 +67,7 @@
 	mod_del_cmd(&set_msgtab);
 }
 
-const char *_version = "$Revision: 1.64.2.7 $";
+const char *_version = "$Revision: 1.5 $";
 #endif
 /* Structure used for the SET table itself */
 struct SetStruct
diff -uNrd ircd-ratbox-1.5-2/modules/m_stats.c ircd-rb-FDF6.3a/modules/m_stats.c
--- ircd-ratbox-1.5-2/modules/m_stats.c	Thu Jun 17 14:01:40 2004
+++ ircd-rb-FDF6.3a/modules/m_stats.c	Thu Jun 17 18:21:01 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_stats.c,v 1.168.2.15 2004/06/17 18:01:40 androsyn Exp $
+ *  $Id: m_stats.c,v 1.5 2004/06/17 22:21:01 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -79,7 +79,7 @@
 	mod_del_cmd(&stats_msgtab);
 }
 
-const char *_version = "$Revision: 1.168.2.15 $";
+const char *_version = "$Revision: 1.5 $";
 #endif
 
 const char *Lformat = ":%s %d %s %s %u %u %u %u %u :%u %u %s";
@@ -124,6 +124,7 @@
 static void stats_uptime(struct Client *);
 static void stats_shared(struct Client *);
 static void stats_servers(struct Client *);
+static void stats_services(struct Client *);
 static void stats_gecos(struct Client *);
 static void stats_class(struct Client *);
 static void stats_memory(struct Client *);
@@ -168,6 +169,8 @@
 	{'Q', stats_resv, 1, 0,},
 	{'r', stats_usage, 1, 0,},
 	{'R', stats_usage, 1, 0,},
+	{'s', stats_services, 1, 0,},
+	{'S', stats_services, 1, 0,},
 	{'t', stats_tstats, 1, 0,},
 	{'T', stats_tstats, 1, 0,},
 	{'u', stats_uptime, 0, 0,},
@@ -472,48 +475,29 @@
 static void
 stats_pending_glines(struct Client *source_p)
 {
-	if(ConfigFileEntry.glines)
-	{
-		dlink_node *pending_node;
-		struct gline_pending *glp_ptr;
-		char timebuffer[MAX_DATE_STRING];
-		struct tm *tmptr;
-
-		DLINK_FOREACH(pending_node, pending_glines.head)
-		{
-			glp_ptr = pending_node->data;
-
-			tmptr = localtime(&glp_ptr->time_request1);
-			strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
+	dlink_node *pending_node;
+	struct gline_pending *glp_ptr;
+	char timebuffer[MAX_DATE_STRING];
+	struct tm *tmptr;
 
-			sendto_one(source_p,
-				   ":%s NOTICE %s :1) %s!%s@%s on %s requested gline at %s for %s@%s [%s]",
-				   me.name, source_p->name, glp_ptr->oper_nick1,
-				   glp_ptr->oper_user1, glp_ptr->oper_host1,
-				   glp_ptr->oper_server1, timebuffer,
-				   glp_ptr->user, glp_ptr->host, glp_ptr->reason1);
+	DLINK_FOREACH(pending_node, pending_glines.head)
+	{
+		glp_ptr = pending_node->data;
 
-			if(glp_ptr->oper_nick2[0])
-			{
-				tmptr = localtime(&glp_ptr->time_request2);
-				strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
-				sendto_one(source_p,
-					   ":%s NOTICE %s :2) %s!%s@%s on %s requested gline at %s for %s@%s [%s]",
-					   me.name, source_p->name, glp_ptr->oper_nick2,
-					   glp_ptr->oper_user2, glp_ptr->oper_host2,
-					   glp_ptr->oper_server2, timebuffer,
-					   glp_ptr->user, glp_ptr->host, glp_ptr->reason2);
-			}
-		}
+		tmptr = localtime(&glp_ptr->time_request1);
+		strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
 
-		if(dlink_list_length(&pending_glines) > 0)
-			sendto_one(source_p, ":%s NOTICE %s :End of Pending G-lines",
-				   me.name, source_p->name);
+		sendto_one(source_p,
+			   ":%s NOTICE %s :1) %s!%s@%s on %s requested gline at %s for %s@%s [%s]",
+			   me.name, source_p->name, glp_ptr->oper_nick1,
+			   glp_ptr->oper_user1, glp_ptr->oper_host1,
+			   glp_ptr->oper_server1, timebuffer,
+			   glp_ptr->user, glp_ptr->host, glp_ptr->reason1);
 	}
-	else
-		sendto_one(source_p, ":%s NOTICE %s :This server does not support G-Lines",
-			   me.name, source_p->name);
 
+	if(dlink_list_length(&pending_glines) > 0)
+		sendto_one(source_p, ":%s NOTICE %s :End of Pending G-lines",
+			   me.name, source_p->name);
 }
 
 /* stats_glines()
@@ -525,25 +509,19 @@
 static void
 stats_glines(struct Client *source_p)
 {
-	if(ConfigFileEntry.glines)
-	{
-		dlink_node *gline_node;
-		struct ConfItem *kill_ptr;
+	dlink_node *gline_node;
+	struct ConfItem *kill_ptr;
 
-		DLINK_FOREACH_PREV(gline_node, glines.tail)
-		{
-			kill_ptr = gline_node->data;
+	DLINK_FOREACH_PREV(gline_node, glines.tail)
+	{
+		kill_ptr = gline_node->data;
 
-			sendto_one(source_p, form_str(RPL_STATSKLINE), me.name,
-				   source_p->name, 'G',
-				   kill_ptr->host ? kill_ptr->host : "*",
-				   kill_ptr->user ? kill_ptr->user : "*",
-				   kill_ptr->passwd ? kill_ptr->passwd : "No Reason");
-		}
+		sendto_one(source_p, form_str(RPL_STATSKLINE), me.name,
+			   source_p->name, 'G',
+			   kill_ptr->host ? kill_ptr->host : "*",
+			   kill_ptr->user ? kill_ptr->user : "*",
+			   kill_ptr->passwd ? kill_ptr->passwd : "No Reason");
 	}
-	else
-		sendto_one(source_p, ":%s NOTICE %s :This server does not support G-Lines",
-			   me.name, source_p->name);
 }
 
 
@@ -980,6 +958,25 @@
 			sendto_one(source_p, form_str(RPL_STATSXLINE),
 				   me.name, source_p->name, 'x',
 				   port, name, pass);
+		}
+	}
+}
+
+static void
+stats_services(struct Client *source_p)
+{
+	struct ConfItem *aconf;
+	char *name, *host, *pass, *user, *classname;
+	int port;
+
+	for (aconf = s_conf; aconf != NULL; aconf = aconf->next)
+	{
+		if(aconf->status & CONF_SLINE)
+		{
+			get_printable_conf(aconf, &name, &host, &pass, &user, &port, &classname);
+
+			sendto_one(source_p, form_str(RPL_STATSSLINE), 
+				   me.name, source_p->name, 'S', name);
 		}
 	}
 }
diff -uNrd ircd-ratbox-1.5-2/modules/m_svinfo.c ircd-rb-FDF6.3a/modules/m_svinfo.c
--- ircd-ratbox-1.5-2/modules/m_svinfo.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_svinfo.c	Mon May 31 00:02:25 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_svinfo.c,v 1.47.2.3 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_svinfo.c,v 1.3 2004/05/31 04:02:25 jailbird Exp $
  */
 #include "stdinc.h"
 #include "handlers.h"
@@ -58,7 +58,7 @@
 	mod_del_cmd(&svinfo_msgtab);
 }
 
-const char *_version = "$Revision: 1.47.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * ms_svinfo - SVINFO message handler
diff -uNrd ircd-ratbox-1.5-2/modules/m_tb.c ircd-rb-FDF6.3a/modules/m_tb.c
--- ircd-ratbox-1.5-2/modules/m_tb.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_tb.c	Mon May 31 00:02:25 2004
@@ -27,7 +27,7 @@
  * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  * POSSIBILITY OF SUCH DAMAGE.
  *
- * $Id: m_tb.c,v 1.1.2.4 2004/05/20 12:06:37 leeh Exp $
+ * $Id: m_tb.c,v 1.4 2004/05/31 04:02:25 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -66,7 +66,7 @@
 	mod_del_cmd(&tb_msgtab);
 }
 
-const char *_version = "$Revision: 1.1.2.4 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 
 /* m_tb()
@@ -121,9 +121,8 @@
 		sendto_channel_local(ALL_MEMBERS, chptr, ":%s TOPIC %s :%s",
 				     source_p->name, chptr->chname, newtopic);
 		sendto_server(client_p, chptr, CAP_TB, NOCAPS,
-			      ":%s TB %s %ld %s%s:%s",
+			      ":%s TB %s %ld %s :%s",
 			      me.name, chptr->chname, chptr->topic_time,
-			      ConfigChannel.burst_topicwho ? chptr->topic_info : "",
-			      ConfigChannel.burst_topicwho ? " " : "", chptr->topic);
+			      chptr->topic_info, chptr->topic);
 	}
 }
diff -uNrd ircd-ratbox-1.5-2/modules/m_testline.c ircd-rb-FDF6.3a/modules/m_testline.c
--- ircd-ratbox-1.5-2/modules/m_testline.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_testline.c	Mon May 31 00:02:25 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_testline.c,v 1.43.2.3 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_testline.c,v 1.3 2004/05/31 04:02:25 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -61,7 +61,7 @@
 	mod_del_cmd(&testline_msgtab);
 }
 
-const char *_version = "$Revision: 1.43.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * mo_testline
